import { jsx as _jsx, Fragment as _Fragment } from "react/jsx-runtime";
import { useMemo } from "react";
import { useRouter } from "./hooks";
export const Route = (props) => {
    const router = useRouter();
    const params = useMemo(() => router.matchRoute(props.path, router.path), [props.path, router]);
    if (!params)
        return null;
    const Component = props.component;
    if (Component) {
        let key;
        if (props.addKey === true)
            key = router.path;
        else if (props.addKey)
            key = props.addKey.map((k) => `${k}=${params[k]}`).join("|");
        return _jsx(Component, { params: params }, key);
    }
    // eslint-disable-next-line react/jsx-no-useless-fragment
    return _jsx(_Fragment, { children: typeof props.children === "function" ? props.children(params) : props.children });
};
