import { PropsWithChildren, FC } from "react";
import { OnNavigateFn } from "./history";
import { RouteMatcherFactory } from "./routeMatcher";
export interface RouterProps {
    basename?: string;
    mode?: "hash" | "path";
    routeMatcherFactory?: RouteMatcherFactory;
    /**
     * An async callback that will be called on a navigation event.
     * If it resolves to false, the navigation event will be aborted
     */
    onNavigate?: OnNavigateFn;
}
export declare const Router: FC<PropsWithChildren<RouterProps>>;
