export type OnNavigateData = {
    from: string;
    to: string;
    type: "push" | "replace";
};
export type OnNavigateFn = (data: OnNavigateData) => Promise<boolean> | boolean;
export interface RouterHistory {
    /** Resolves to false if onNavigate resolved to false */
    push: (path: string) => Promise<boolean>;
    /** Resolves to false if onNavigate resolved to false */
    replace: (path: string) => Promise<boolean>;
    onChange: () => void;
    urlTo: (path: string) => string;
}
export declare const getHashPath: () => string;
type CreateHistoryOptions = {
    hashMode: boolean;
    basename: string;
    setPath: (path: string) => void;
    onNavigate?: OnNavigateFn;
};
export declare function createHistory({ hashMode, basename, setPath, onNavigate }: CreateHistoryOptions): RouterHistory;
export {};
