var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { getPathWithoutBasename } from "./basename";
export const getHashPath = () => window.location.hash.substr(1);
export function createHistory({ hashMode, basename, setPath, onNavigate }) {
    const { location, history } = window;
    const onChange = hashMode ? () => setPath(getHashPath()) : () => setPath(getPathWithoutBasename(basename));
    const urlTo = hashMode
        ? (path) => `${location.pathname}${location.search}#${path}`
        : (path) => `${basename}${path}`;
    function historyAction(path, type) {
        return __awaiter(this, void 0, void 0, function* () {
            const to = urlTo(path);
            const from = location.pathname + location.search + location.hash;
            // Only push if something changed.
            if (to !== from) {
                if (onNavigate) {
                    const allowed = yield onNavigate({ from, to, type: "push" });
                    if (!allowed)
                        return false;
                }
                if (type === "push")
                    history.pushState({}, "", to);
                else
                    history.replaceState({}, "", to);
                onChange();
            }
            return true;
        });
    }
    return {
        push: (path) => historyAction(path, "push"),
        replace: (path) => historyAction(path, "replace"),
        onChange,
        urlTo,
    };
}
